package com.exquisiteapplicationsolutions.tis.syncClasses;

import android.app.Activity;
import android.content.ContentValues;
import android.content.Context;
import android.content.SharedPreferences;
import android.util.Log;

import com.exquisiteapplicationsolutions.tis.DBParameters;
import com.exquisiteapplicationsolutions.tis.TISDBHelper;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.util.ArrayList;

;

/**
 * Created by cairnsj on 6/14/15.
 */
public class SyncUsers {
    private static final int TIMEOUT_MILLISEC = 600;
    private static final String sDBName = "TIS.db";
    public static Activity inActivity;
    public static Context oContext;
    public static String sUserName;
    private static final int iVersionVal = 8;

    public static void getUsers() throws Exception {
        String data = "";

        SharedPreferences prefs = oContext.getSharedPreferences("TISSharedPrefs",
                Context.MODE_PRIVATE);
        sUserName = prefs.getString("UserID", "No Value");
        // need to get the last message id that was last syncd from the server
        int iLastSyncMsgID = lastUserIdSync();

        DBParameters oDBParameters = new DBParameters();

        // WebServer Request URL
        String serverURL = oDBParameters.readParameter(
                "REST_BASE_URL", oContext, sDBName,
                iVersionVal);

        serverURL += "userSync.php";

        try {
            // Set Request parameter
            data += "&" + URLEncoder.encode("lastId", "UTF-8") + "=" + iLastSyncMsgID;
        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        /************ Make Post Call To Web Server ***********/
        BufferedReader reader = null;
        StringBuilder sb = new StringBuilder();

        // Send data
        try {

            // Defined URL  where to send data
            URL url = new URL(serverURL);

            // Send POST data request
            URLConnection conn = url.openConnection();
            conn.setDoOutput(true);
            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
            wr.write(data);
            wr.flush();

            // Get the server response
            reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String line = null;

            // Read Server Response
            while ((line = reader.readLine()) != null) {
                // Append server response in string
                sb.append(line + "");

            }
        } catch (Exception ex) {
            ex.printStackTrace();
            Log.e("SyncUsers Error:", ex.toString());
        } finally {
            try {
                reader.close();
            } catch (Exception ex) {
            }
        }

        // put the information into the database
        TISDBHelper oDB = new TISDBHelper(oContext, sDBName, null, iVersionVal);
        try {
            oDB.createDataBase();
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        }

        oDB.openDataBase();

        try {
            JSONArray oJsonArray = new JSONArray(sb.toString());
            int iTest = oJsonArray.length();

            for (int iCounter = 0; iCounter < oJsonArray.length(); iCounter++) {
                JSONObject json = oJsonArray.getJSONObject(iCounter);
                ContentValues oValues = new ContentValues();
                oValues.put("paid", json.getString("paid"));
                oValues.put("FirstName", json.getString("first_name"));
                oValues.put("LastName", json.getString("last_name"));
                oValues.put("EmailAddress", json.getString("email_address"));
                oValues.put("Title", json.getString("title"));
                //Always make sure the userID is lower case
                oValues.put("UserID", json.getString("username").toLowerCase());
                oValues.put("DriverImageTaken", json.getString("image_name"));
                oValues.put("id", json.getString("id"));
                oValues.put("CompanyName", json.getString("companyName"));
                //oValues.put("AcceptedUsagePolicy", json.getString("acceptedUsagePolicy"));

                //Only try to insert if the userid does not equal logged in user
                if (!oValues.get("UserID").equals(sUserName.toLowerCase())) {
                    try {
                        oDB.insertRecordsInDB("EmployeeMaster", null, oValues);
                    } catch (Exception sqlEx) {
                        Log.e("sqlEx:", sqlEx.toString());
                    }
                } else {
                    //It is equal to the logged in user so update instead
                    try {
                        oDB.updateRecordsInDB("EmployeeMaster","UserID = '" + oValues.get("UserID") + "'" , oValues);
                    } catch (Exception sqlEx) {
                        Log.e("sqlEx:", sqlEx.toString());
                    }
                }
            }
        } catch (Throwable t) {
            Log.d("getUsers():", t.toString());
            t.printStackTrace();
        } finally {
            oDB.close();
        }
    }

    private static int lastUserIdSync() {
        int iRtnVal = 0;

        // put the information into the database
        TISDBHelper oDB = new TISDBHelper(oContext, sDBName, null, iVersionVal);
        try {
            oDB.createDataBase();
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        }

        oDB.openDataBase();
        String sSQL = "select max(id) from EmployeeMaster";
        ArrayList<ArrayList<String>> sStringList = oDB.selectRecordsFromDBList(
                sSQL, null);
        oDB.close();

        if (sStringList != null) {
            for (int i = 0; i < sStringList.size(); i++) {
                int iSize = sStringList.size();
                ArrayList<String> tempList = sStringList.get(i);
                try {
                    iRtnVal = Integer.parseInt(tempList.get(0));
                } catch (Exception ex) {
                    iRtnVal = 0;
                }
            }
        } else {
            iRtnVal=0;
        }

        return iRtnVal;
    }

    public static Boolean updProfile(String sUserName) throws Exception {
        Boolean bRtnVal = false;
        String data = "";
        String sFirstName = "";
        String sLastName = "";
        String sPassword = "";
        String sImageName = "";
        String sSignatureName = "";
        String sEmailAddress = "";
        String sTitle = "";
        String sAcceptedUsagePolicy = "";
        String sCompanyName = "";

        // get the data from the database for the user
        // put the information into the database
        TISDBHelper oDB = new TISDBHelper(oContext, sDBName, null, iVersionVal);
        try {
            oDB.createDataBase();
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        }

        oDB.openDataBase();
        String sSQL = "select FirstName, LastName, Password, DriverImageTaken, '', EmailAddress, Title, AcceptedUsagePolicy, CompanyName from EmployeeMaster ";
        sSQL += "where UserID = '" + sUserName.toLowerCase() + "' ";
        sSQL += "and Password <> '' ";

        ArrayList<ArrayList<String>> sStringList = oDB.selectRecordsFromDBList(
                sSQL, null);
        oDB.close();

        if (sStringList != null) {
            for (int i = 0; i < sStringList.size(); i++) {
                int iSize = sStringList.size();
                ArrayList<String> tempList = sStringList.get(i);
                try {
                    sFirstName = tempList.get(0);
                    sLastName = tempList.get(1);
                    sPassword = tempList.get(2);
                    sImageName = tempList.get(3);
                    sSignatureName = tempList.get(4);
                    sEmailAddress = tempList.get(5);
                    sTitle = tempList.get(6);
                    sAcceptedUsagePolicy = tempList.get(7);
                    sCompanyName = tempList.get(8);
                } catch (Exception ex) {
                }
            }
        }

        DBParameters oDBParameters = new DBParameters();

        // WebServer Request URL
        String serverURL = oDBParameters.readParameter(
                "REST_BASE_URL", oContext, sDBName,
                iVersionVal);

        serverURL += "updUserInfoWS.php";


        try {
            // Set Request parameter
            data += "&" + URLEncoder.encode("firstName", "UTF-8") + "=" + sFirstName;
            data += "&" + URLEncoder.encode("lastName", "UTF-8") + "=" + sLastName;
            data += "&" + URLEncoder.encode("password", "UTF-8") + "=" + sPassword;
            data += "&" + URLEncoder.encode("imageName", "UTF-8") + "=" + sImageName;
            data += "&" + URLEncoder.encode("signatureName", "UTF-8") + "=" + sSignatureName;
            data += "&" + URLEncoder.encode("userID", "UTF-8") + "=" + sUserName;
            data += "&" + URLEncoder.encode("emailAddress", "UTF-8") + "=" + sEmailAddress;
            data += "&" + URLEncoder.encode("title", "UTF-8") + "=" + sTitle;
            data += "&" + URLEncoder.encode("acceptedUsagePolicy", "UTF-8") + "=" + sAcceptedUsagePolicy;
            data += "&" + URLEncoder.encode("companyName", "UTF-8") + "=" + sCompanyName;

        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        /************ Make Post Call To Web Server ***********/
        BufferedReader reader = null;
        StringBuilder sb = new StringBuilder();

        // Send data
        try {

            // Defined URL  where to send data
            URL url = new URL(serverURL);

            // Send POST data request
            URLConnection conn = url.openConnection();
            conn.setDoOutput(true);
            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
            wr.write(data);
            wr.flush();

            // Get the server response
            reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String line = null;

            // Read Server Response
            while ((line = reader.readLine()) != null) {
                // Append server response in string
                sb.append(line + "");

            }
            bRtnVal = true;
        } catch (Exception ex) {
            ex.printStackTrace();
            Log.e("SyncUsers Error:", ex.toString());
        } finally {
            try {
                reader.close();
            } catch (Exception ex) {
            }
        }

        return bRtnVal;
    }

    public static void refreshProfile() throws Exception {
        String data = "";

        DBParameters oDBParameters = new DBParameters();

        // WebServer Request URL
        String serverURL = oDBParameters.readParameter(
                "REST_BASE_URL", oContext, sDBName,
                iVersionVal);

        serverURL += "userRefresh.php";

        try {
            // Set Request parameter
            data += "&" + URLEncoder.encode("userName", "UTF-8") + "=" + sUserName;
        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        /************ Make Post Call To Web Server ***********/
        BufferedReader reader = null;
        StringBuilder sb = new StringBuilder();

        // Send data
        try {

            // Defined URL  where to send data
            URL url = new URL(serverURL);

            // Send POST data request
            URLConnection conn = url.openConnection();
            conn.setDoOutput(true);
            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
            wr.write(data);
            wr.flush();

            // Get the server response
            reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String line = null;

            // Read Server Response
            while ((line = reader.readLine()) != null) {
                // Append server response in string
                sb.append(line + "");

            }
        } catch (Exception ex) {
            ex.printStackTrace();
            Log.e("SyncUsers Error:", ex.toString());
        } finally {
            try {
                reader.close();
            } catch (Exception ex) {
            }
        }

        // put the information into the database
        TISDBHelper oDB = new TISDBHelper(oContext, sDBName, null, iVersionVal);
        try {
            oDB.createDataBase();
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        }

        oDB.openDataBase();

        try {
            JSONArray oJsonArray = new JSONArray(sb.toString());
            int iTest = oJsonArray.length();

            for (int iCounter = 0; iCounter < oJsonArray.length(); iCounter++) {
                JSONObject json = oJsonArray.getJSONObject(iCounter);
                ContentValues oValues = new ContentValues();
                oValues.put("paid", json.getString("paid"));
                oValues.put("FirstName", json.getString("first_name"));
                oValues.put("LastName", json.getString("last_name"));
                oValues.put("EmailAddress", json.getString("email_address"));
                oValues.put("Title", json.getString("title"));
                //Always make sure the userID is lower case
                oValues.put("UserID", json.getString("username").toLowerCase());
                oValues.put("DriverImageTaken", json.getString("image_name"));
                oValues.put("CompanyName", json.getString("companyName"));
                //oValues.put("AcceptedUsagePolicy", json.getString("acceptedUsagePolicy"));

                //Only try to insert if the userid does not equal logged in user
                //It is equal to the logged in user so update instead
                try {
                    oDB.updateRecordsInDB("EmployeeMaster","UserID = '" + oValues.get("UserID") + "'" , oValues);
                } catch (Exception sqlEx) {
                    Log.e("sqlEx:", sqlEx.toString());
                }
            }
        } catch (Throwable t) {
            Log.d("getUsers():", t.toString());
            t.printStackTrace();
        } finally {
            oDB.close();
        }
    }

}
